##########################################################################
# Copyright (c) 2012 W. Evan Johnson, Boston University School of Medicine
#
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
##########################################################################

import os, sys, glob
import utilities

inFilePath = sys.argv[1]
filterExpression = sys.argv[2]
numHeaderRows = int(sys.argv[3])
outFilePath = sys.argv[4]

inFile = open(inFilePath)
outFile = open(outFilePath, 'w')

def filterAndWrite(data):
    data = filter(lambda x: eval(filterExpression), data)

    for row in data:
        outFile.write("\t".join(row) + "\n")

    return len(data)

for i in range(numHeaderRows):
    outFile.write(inFile.readline())

linesRead = 0
linesWritten = 0
data = []

for line in inFile:
    data.append(line.rstrip().split("\t"))
    linesRead += 1

    if len(data) == 100000:
        print "Data rows read: %i" % linesRead
        linesWritten += filterAndWrite(data)
        data = []

linesWritten += filterAndWrite(data)

outFile.close()
inFile.close()

print "Data rows read: %i" % linesRead
print "Data rows after filtering: %i" % linesWritten
