visualizationFilter <-
function(data,lc,N,start='NULL') {
	if (start=='NULL') {
		start <- ifelse(is.numeric(data[1,1])==TRUE,1,2)
		}
	gmean <- apply(data[,start:ncol(data)],1,mean)
	tmean <- mean(gmean)

	temp <- (data[,start:ncol(data)] - apply(data[,start:ncol(data)],1,mean))^2

	s.sq <- sum(temp)/(length(gmean)*(ncol(data)-start))
	Yij <- (data[1:nrow(data),start:ncol(data)]-tmean)/sqrt(s.sq)
	mu <- apply(Yij,1,mean)
	sig <- apply(Yij,1,sd)
	criteria <- sig/mu
		
	filter1 <- data[as.vector(which(criteria >= lc)),]
	newcriteria <- criteria[as.vector(which(criteria >= lc))]
		
	newdata <- NULL
	newdata <- filter1[order(newcriteria)[1:N],]

	decomp <- svd(newdata[,start:ncol(data)])
	svd.D <- decomp$d
	svd.U <- decomp$u
	svd.V <- decomp$v
	
	results <- list(filtered.data=newdata,svd.D=svd.D,svd.U=svd.U,svd.V=svd.V)
	
	return(results)

}

